'From Squeak3.4beta of ''1 December 2002'' [latest update: #5147] on 10 December 2002 at 12:07:03 am'!
"Change Set:		CelesteCleanUp1
Date:			9 December 2002
Author:			Daniel Vainsencher

Add a class MailSender that abstracts sending a message. Holds a registry of mail composition GUIs it can use. Remembers the users sending account details."!

Object subclass: #MailSender
	instanceVariableNames: ''
	classVariableNames: 'MailSenderRegistry PreferredMailSender SmtpServer UserName '
	poolDictionaries: ''
	category: 'Network-MailSending'!

!MailSender class methodsFor: 'as yet unclassified' stamp: 'dvf 5/11/2002 01:31'!
isSmtpServerSet
	^ SmtpServer notNil and: [SmtpServer notEmpty]
! !

!MailSender class methodsFor: 'as yet unclassified' stamp: 'dvf 5/11/2002 00:37'!
preferredMailSender 
	| menu | 
	^PreferredMailSender ifNil: [
	menu _ CustomMenu new.
	self registeredMailSenderClasses do: [:c | menu add: c name printString action: c].
	PreferredMailSender _ menu startUp].
! !

!MailSender class methodsFor: 'as yet unclassified' stamp: 'dvf 5/10/2002 23:32'!
registerMailSender: aProviderClass
	| registeredSenders |
	registeredSenders := self registeredMailSenderClasses.
	(registeredSenders includes: aProviderClass) 
			ifFalse: [ registeredSenders addLast: aProviderClass ]! !

!MailSender class methodsFor: 'as yet unclassified' stamp: 'dvf 5/10/2002 23:33'!
registeredMailSenderClasses

	MailSenderRegistry ifNil: [MailSenderRegistry _ OrderedCollection new].
	^ MailSenderRegistry
! !

!MailSender class methodsFor: 'as yet unclassified' stamp: 'dvf 11/21/2002 22:47'!
sendMessage: aMailMessage

	self preferredMailSender ifNotNil: [self preferredMailSender sendMailMessage: aMailMessage]! !

!MailSender class methodsFor: 'as yet unclassified' stamp: 'dvf 5/11/2002 01:34'!
setSmtpServer
	"Set the SMTP server used to send outgoing messages via"
	SmtpServer ifNil: [SmtpServer _ ''].
	SmtpServer _ FillInTheBlank
		request: 'What is your mail server for outgoing mail?'
		initialAnswer: SmtpServer.
! !

!MailSender class methodsFor: 'as yet unclassified' stamp: 'dvf 5/11/2002 00:49'!
setUserName
	"Change the user's email name for use in composing messages."

	(UserName isNil) ifTrue: [UserName _ ''].
	UserName _ FillInTheBlank
		request: 'What is your email address?\(This is the address other people will reply to you)' withCRs
		initialAnswer: UserName isoToSqueak.
	UserName ifNotNil: [UserName _ UserName squeakToIso]! !

!MailSender class methodsFor: 'as yet unclassified' stamp: 'dvf 5/11/2002 01:29'!
smtpServer
	"Answer the server for sending email"

	self isSmtpServerSet
		ifFalse: [self setSmtpServer].
	SmtpServer isEmpty ifTrue: [
		self error: 'no SMTP server specified' ].

	^SmtpServer! !

!MailSender class methodsFor: 'as yet unclassified' stamp: 'dvf 5/11/2002 00:35'!
unregisterMailSender: aProviderClass
	| |
	(PreferredMailSender = aProviderClass) ifTrue: [PreferredMailSender _ nil].
	self registeredMailSenderClasses remove: aProviderClass ifAbsent: [].! !

!MailSender class methodsFor: 'as yet unclassified' stamp: 'dvf 5/11/2002 00:49'!
userName
	"Answer the user name to be used in composing messages."

	(UserName isNil or: [UserName isEmpty])
		ifTrue: [self setUserName].

	UserName isEmpty ifTrue: [ self error: 'no user name specified' ].

	^UserName! !

"Postscript:
Recategorize classes that aren't really specific to Celeste"
SystemOrganization classify: #MailMessage under: 'Network-Url'.
SystemOrganization classify: #TextMessageLink under: 'Network-Url'.
SystemOrganization classify: #MIMEHeaderValue under: 'Network-Url'.

!

